<?php
	// 20090518 - Remove Start
	// version control
	if (substr_count(strtolower($version), "standard") > 0) {
        if (substr_count(strtolower($version),"donation")>0)
            $version = substr($version,0,strlen($version)-9);
        $disabled = ' disabled';
        $version_msg = '* This feature is not available in '. ucwords($version) .' Edition.';
        $version_star = '<span class="star">* </span>';
    } else {
        $disabled = '';
        $version_msg = '';
        $version_star = '';
    }

    // create the COM object
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');

    echo '<script type="text/javascript" src="./javascript/print.js"></script>'."\n";
    echo '<form name="print_form" action="settingok.php" method="post" onsubmit="return validate_print();">'."\n";
    
    gen_head();
    gen_license_warning($version_msg);

    // get all the config value from config.ini
    $print_support = $settingobj->getKey('PrintSupport', 'PrinterOn');
    $siteURL = $settingobj->getKey('SiteURL', 'PrinterOn');
    $siteUID = $settingobj->getKey('SiteUID', 'PrinterOn');
    $siteAuth = $settingobj->getKey('SiteAuth', 'PrinterOn');
    $login_checked = $settingobj->getKey('show_URL_login', 'PrinterOn');
    $infobox_checked = $settingobj->getKey('show_URL_infobox', 'PrinterOn');
    // release the COM object
    //$settingobj->Release();
    $settingobj=null;

    // PrintSupport On/ Off
    if ($print_support == 0) {
        $input = '<input type="radio" name="print_support" value="1" '.$disabled.' onclick="print_support_trigger();">On'."\n";
        $input .= '<input type="radio" name="print_support" value="0" checked '.$disabled.' onclick="print_support_trigger();">Off';
    } else {
        $input = '<input type="radio" name="print_support" value="1" checked '.$disabled.' onclick="print_support_trigger();">On'."\n";
        $input .= '<input type="radio" name="print_support" value="0" '.$disabled.' onclick="print_support_trigger();">Off';
    }

    gen_line($version_star.get_cm_var('setcfg_print_printing'), $input);
    gen_sep();

    // PrintSpot Web Page URL
    $input = '<input type="text" name="siteURL" class="longtextbox" value="'.$siteURL.'" '.$disabled.' onfocus="this.select();">';

    gen_line(get_cm_var('setcfg_print_url'), $input);
    gen_sep();

    // Show siteURL options
    if ($login_checked == 0) {
        $input = '<input type="checkbox" name="show_login" value="1" '.$disabled.'>Login page';
    } else {
        $input = '<input type="checkbox" name="show_login" value="1" checked '.$disabled.'>Login page';
    }
    if ($infobox_checked == 0) {
        $input .= '<input type="checkbox" name="show_info" value="1" '.$disabled.'>InfoBox';
    } else {
        $input .= '<input type="checkbox" name="show_info" value="1" checked '.$disabled.'>InfoBox';
    }

    gen_line('Show URL at:', $input ,1);
    gen_sep();

    // Security mode
    $input = '<select id="security_mode" name="security_mode" '.$disabled.' onchange="disable_option();">';
    if (($siteUID=='') && ($siteAuth=='')) {
        $input .= '<option value="cleartext" selected>Clear Text';
        $input .= '<option value="md5">MD5';
    } else {
        $input .= '<option value="cleartext">Clear Text';
        $input .= '<option value="md5" selected>MD5';
    }
    $input .= '</select>';

    gen_line(get_cm_var('setcfg_print_mode'), $input);
    gen_sep();

    // SiteUID
    $input = '<input type="text" name="siteUID" class="longtextbox" value="'.$siteUID.'" '.$disabled.' onfocus="this.select();">';

    gen_line(get_cm_var('setcfg_print_uid'), $input);
    gen_sep();

    // SiteAuth
    $input = '<input type="text" name="siteAuth" class="longtextbox" value="'.$siteAuth.'" '.$disabled.' onfocus="this.select();">';

    gen_line(get_cm_var('setcfg_print_auth'), $input);
    gen_sep();

    gen_save('save_print',$fs_status);

?>

    <!-- show log & export log buttons -->
    <tr>
        <td colspan="9">
        <form id="export_form" action="settingok.php" method="post">
            <img src="./images/showlog.gif" alt="Show Log" title="Show Log" id="log_button" style="cursor:pointer;cursor:hand;" onclick="show_log();">
            <img src="./images/exportcclog.gif" alt="Export Log" title="Export Log" style="cursor:pointer;cursor:hand;" onclick="document.getElementById('export_form').submit();">
            <input name="export_print_log" type="hidden" value="true">
        </form>
        </td>
    </tr>
    <!-- print log -->
    <tr id="log">
        <td colspan="9">
            <iframe frameborder="0" width="740" height="20" src="print_log_label.php" marginwidth="2" marginheight="0"></iframe><br>
            <iframe class="bordered_frame" frameborder="0" width="740" height="300" src="print_log.php" marginwidth="2" marginheight="0"></iframe><br><br>
        </td>
    </tr>

<?php
    gen_foot();
?>
    <script type="text/javascript">
    <!--
        print_support_trigger();
        document.getElementById('log').style.display = 'none';
    // -->
    </script>
