// NAT Script
function showNAT(showTxt, hideTxt)
{
    if(document.getElementById("ipPoolButton").value == showTxt)
    	document.getElementById("ipPoolButton").value = hideTxt;
    else
    	document.getElementById("ipPoolButton").value = showTxt;
    
    if(document.getElementById("NatAddrRange").style.display == "none")
    	document.getElementById("NatAddrRange").style.display = "";
    else
    	document.getElementById("NatAddrRange").style.display = "none";
}

function SwitchNAT(instance)
{
	if(instance.value == 1) {
		document.all.proxyARP_enabled[0].checked = false;
        document.all.proxyARP_enabled[1].checked = true;
        document.all.proxyARP_enabled[0].disabled = true;
        document.all.proxyARP_enabled[1].disabled = true;
        document.getElementById("NatRadioButtons").style.display = "";
        
        if(document.all.nat_option[1].checked)
        	NatOption(document.all.nat_option[1]);
        else if(document.all.nat_option[2].checked)
        	NatOption(document.all.nat_option[2]);
    }
	else {
        document.all.proxyARP_enabled[0].disabled = false;
        document.all.proxyARP_enabled[1].disabled = false;
        document.getElementById("NatRadioButtons").style.display = "none";
        NatOption(0);
    }
		
}

function NatOption(instance)
{
	if(instance.value == 1) {
		document.getElementById('NatAddrRange').style.display = '';
		document.getElementById('NatPortMapping').style.display = 'none';
	}
	else if(instance.value == 2) {
		document.getElementById('NatAddrRange').style.display = 'none';
		document.getElementById('NatPortMapping').style.display = '';
	}
	else {
		document.getElementById('NatPortMapping').style.display = 'none';
		document.getElementById('NatAddrRange').style.display = 'none';
	}
}

//NAT Address Mapping
function addEntry()
{
    oForm = document.c_Nat;
      
    var formValue = new Array(12);
    formValue[0] = oForm.NAT_start_ip1.value;
    formValue[1] = oForm.NAT_start_ip2.value;
    formValue[2] = oForm.NAT_start_ip3.value;
    formValue[3] = oForm.NAT_start_ip4.value;
    
    formValue[4] = oForm.NAT_end_ip1.value;
    formValue[5] = oForm.NAT_end_ip2.value;
    formValue[6] = oForm.NAT_end_ip3.value;
    formValue[7] = oForm.NAT_end_ip4.value;
    
    formValue[8] = oForm.NAT_mask_ip1.value;
    formValue[9] = oForm.NAT_mask_ip2.value;
    formValue[10] = oForm.NAT_mask_ip3.value;
    formValue[11] = oForm.NAT_mask_ip4.value;
    
    //Verify IP
    for(i=0; i<12; i++)
   		if(formValue[i]=="" || formValue[i]>255) {
   			alert('Invalid IP!');
   			return false;
		}
	
	//Verify Address Range
	ipS = ip2long(formValue[0],formValue[1],formValue[2],formValue[3]);
	ipE = ip2long(formValue[4],formValue[5],formValue[6],formValue[7]);
			
	if(ipE<ipS) {
		alert('Invalid Address Range!');
   		return false;
	}
	
	//Form Post String
    formValue[0] = "start_ip1="+oForm.NAT_start_ip1.value;
    formValue[1] = "start_ip2="+oForm.NAT_start_ip2.value;
    formValue[2] = "start_ip3="+oForm.NAT_start_ip3.value;
    formValue[3] = "start_ip4="+oForm.NAT_start_ip4.value;
    
    formValue[4] = "end_ip1="+oForm.NAT_end_ip1.value;
    formValue[5] = "end_ip2="+oForm.NAT_end_ip2.value;
    formValue[6] = "end_ip3="+oForm.NAT_end_ip3.value;
    formValue[7] = "end_ip4="+oForm.NAT_end_ip4.value;
    
    formValue[8] = "mask_ip1="+oForm.NAT_mask_ip1.value;
    formValue[9] = "mask_ip2="+oForm.NAT_mask_ip2.value;
    formValue[10] = "mask_ip3="+oForm.NAT_mask_ip3.value;
    formValue[11] = "mask_ip4="+oForm.NAT_mask_ip4.value;
	
    urlenStr = formValue.join("&");
   
    window.frames.frameNAT.location = "frameNAT.php?"+urlenStr;
    
    return false;
}

function deleteEntry()
{
    objEntry = window.frames.frameNAT.document.getElementsByName("entry");
    
    var j=0;
    var entry = new Array();
    var deleteStr = null;
    
    for (i=0; i<objEntry.length; i++) {
        if (objEntry[i].checked==true){
            entry[j]=i;
            j++;
        }
    }
        
   	deleteStr = entry.join(",");
    
    if(deleteStr == null || deleteStr == '' )
        return;
    
    document.getElementById("NATdeleteTxt").style.display = "";
    window.frames.frameNAT.location = "frameNAT.php?delete="+deleteStr;
}

//NAT Port Forwarding
function addPortMap()
{
    oForm = document.c_Nat;
    
    if(!checkIP(oForm.NAT_port_ip1.value,oForm.NAT_port_ip2.value,oForm.NAT_port_ip3.value,oForm.NAT_port_ip4.value)) {
    	alert('Invalid IP address!');
    	return false;
	}
	
	if (oForm.NAT_public_port.value >65535 || 0> oForm.NAT_public_port.value || oForm.NAT_private_port.value >65535 || 0> oForm.NAT_private_port.value){
		alert('Invalid port number');
    	return false;
	}

    // 20080320 - Public port checking
    oTagTable = window.frames.framePortMap.document.getElementsByTagName("table");
    for (i = 0; i < oTagTable.length; i++) {
	if (oTagTable[i].getAttribute("id") == "tablePortMap") {
	    errPubPort = oTagTable[i].getAttribute("errPubPort");
	}
    }
    oTagTr = window.frames.framePortMap.document.getElementsByTagName("tr");
    for (i = 0; i < oTagTr.length; i++) {
	if (oTagTr[i].getAttribute("id") == "portId" && oTagTr[i].getAttribute("value") == oForm.NAT_public_port.value) {
	    alert(errPubPort);
	    return false;
	}
    }
    
    var formValue = new Array(8);
    formValue[0] = "NAT_port_ip1="+oForm.NAT_port_ip1.value;
    formValue[1] = "NAT_port_ip2="+oForm.NAT_port_ip2.value;
    formValue[2] = "NAT_port_ip3="+oForm.NAT_port_ip3.value;
    formValue[3] = "NAT_port_ip4="+oForm.NAT_port_ip4.value;
    
    formValue[4] = "NAT_private_port="+oForm.NAT_private_port.value;
    formValue[5] = "NAT_public_port="+oForm.NAT_public_port.value;
    
    if(oForm.NAT_proto_tcp.checked)
    	formValue[6] = "NAT_proto_tcp="+oForm.NAT_proto_tcp.value;
    	
   	if(oForm.NAT_proto_udp.checked)
    	formValue[7] = "NAT_proto_udp="+oForm.NAT_proto_udp.value;
    
    urlenStr = formValue.join("&");
   	
    window.frames.framePortMap.location = "framePortMap.php?"+urlenStr;
    
    return false;
}

function deletePortMap()
{
    objEntry = window.frames.framePortMap.document.getElementsByName("entry");
    
    var j=0;
    var entry = new Array();
    var deleteStr = null;
    
    for (i=0; i<objEntry.length; i++) {
        if (objEntry[i].checked==true){
            entry[j]=i;
            j++;
        }
    }
        
   	deleteStr = entry.join(",");
    
    if(deleteStr == null || deleteStr == '' )
        return;
    
    document.getElementById("NAT_portmap_deleteTxt").style.display = "";
    window.frames.framePortMap.location = "framePortMap.php?delete="+deleteStr;
}

// NAT Script End

// Proxy ARP script
function addEntryProxyARP()
{
    oForm = document.c_Nat;
    
    var formValue = new Array(8);
    formValue[0] = oForm.ProxyARP_start_ip1.value;
    formValue[1] = oForm.ProxyARP_start_ip2.value;
    formValue[2] = oForm.ProxyARP_start_ip3.value;
    formValue[3] = oForm.ProxyARP_start_ip4.value;
    
    formValue[4] = oForm.ProxyARP_end_ip1.value;
    formValue[5] = oForm.ProxyARP_end_ip2.value;
    formValue[6] = oForm.ProxyARP_end_ip3.value;
    formValue[7] = oForm.ProxyARP_end_ip4.value;
    
    //Verify IP
    for(i=0; i<8; i++)
   		if(formValue[i]=="" || formValue[i]>255) {
   			alert('Invalid IP!');
   			return false;
		}
	
	//Verify Address Range
	ipS = ip2long(formValue[0],formValue[1],formValue[2],formValue[3]);
	ipE = ip2long(formValue[4],formValue[5],formValue[6],formValue[7]);
			
	if(ipE<ipS) {
		alert('Invalid Address Range!');
   		return false;
	}
    
    //Form post string
    formValue[0] = "start_ip1="+oForm.ProxyARP_start_ip1.value;
    formValue[1] = "start_ip2="+oForm.ProxyARP_start_ip2.value;
    formValue[2] = "start_ip3="+oForm.ProxyARP_start_ip3.value;
    formValue[3] = "start_ip4="+oForm.ProxyARP_start_ip4.value;
    
    formValue[4] = "end_ip1="+oForm.ProxyARP_end_ip1.value;
    formValue[5] = "end_ip2="+oForm.ProxyARP_end_ip2.value;
    formValue[6] = "end_ip3="+oForm.ProxyARP_end_ip3.value;
    formValue[7] = "end_ip4="+oForm.ProxyARP_end_ip4.value;
    
    urlenStr = formValue.join("&");
    
    window.frames.frameProxyARP.location = "frameProxyARP.php?"+urlenStr;
    
    return false;
}

function deleteEntryProxyARP()
{
    objEntry = window.frames.frameProxyARP.document.getElementsByName("entry");
    
    var j=0;
    var entry = new Array();
    var deleteStr = null;
    
    for (i=0; i<objEntry.length; i++) {
        if (objEntry[i].checked==true){
            entry[j]=i;
            j++;
        }
    }
        
   	deleteStr = entry.join(",");
    
    if(deleteStr == null || deleteStr == '' )
        return;
    
    document.getElementById("ProxyARPdeleteTxt").style.display = "";
    window.frames.frameProxyARP.location = "frameProxyARP.php?delete="+deleteStr;
}

function showProxyARP(instance)
{
    if(instance.value == 1) {
        document.getElementById("proxyARP_table").style.display = "";
        
        document.c_Nat.nat_enabled[0].checked = false;
        document.c_Nat.nat_enabled[1].checked = true;
        document.c_Nat.nat_enabled[0].disabled = true;
        document.c_Nat.nat_enabled[1].disabled = true;
    }
    else {
        document.getElementById("proxyARP_table").style.display = "none";
        
        document.c_Nat.nat_enabled[0].disabled = false;
        document.c_Nat.nat_enabled[1].disabled = false;
    }   
}
// Proxy ARP End

// Common script for NAT & Proxy ARP
function selectAll(obj)
{
    for (i=0; i<obj.length; i++)
        obj[i].checked = (obj[i].disabled)?false:true;
            
    return false;
}

function selectClear(obj)
{   
    for (i=0; i<obj.length; i++)
        obj[i].checked = false;
        
    return false;
}

function ip2long(ip1, ip2, ip3, ip4)
{
	iplong1 = ip1 * 0x1000000;
	iplong2 = ip2 * 0x10000;
	iplong3 = ip3 * 0x100;
    // 20080206 - Bug fix (0x1)
    iplong4 = ip4 * 0x1;
	
	return iplong1+iplong2+iplong3+iplong4;
}
