<?
    include "..\\authserv\\common_functions.php";
    $print_table=fs_printlog_table();
    $fsusr_table=fs_usr_table();

    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');

    $version = $settingobj->getKey('version', 'version');

    // release the COM object
    //$settingobj->Release();
    $settingobj=null;

	// 20090518 - Remove Start
	// version control
	if (substr_count(strtolower($version), "standard") > 0) {
        if (substr_count(strtolower($version),"donation")>0)
            $version = substr($version,0,strlen($version)-9);
        $version_check = false;
    } else {
        $version_check = true;

    }

    if($version_check)
    {
        $print_log="..\\log\\printing.log";
        if (is_file($print_log) == FALSE)
        {
                touch ($print_log);
                $log_msg_heading="Remote IP\tUsername\tjobReferenceID\tjobType\tjobDestination\tjobPageCount\tjobCoverPage\tjobMediaSizeName\tjobColor\tjobReleasePort\tjobDateTime\tjobPriceTotal\tdocFormatApp\tLog Strings\r\n";
                $fileHandler = fopen ($print_log, "w");
                fwrite ($fileHandler, $log_msg_heading);
                fclose ($fileHandler);
        }
        $log_msg_content="";
        $log_msg_ip=$_SERVER["REMOTE_ADDR"];
        $log_msg_strings="";
        $log_msg_strings_posted="";

        $lock_file="..\\log\\lockprinting";
        $lock_count = 0;

        if(is_file($lock_file) == TRUE && (time() - filemtime($lock_file)>180)) //error recovery
        {
            unlink($lock_file);
        }

        while (is_file($lock_file) == TRUE)
        {
            clearstatcache();
            sleep(1);
            $lock_count = $lock_count + 1;
            if ($lock_count > 180)
            {
                $log_msg_strings.="Fail to lock file. ";
                break;
            }
        }

        clearstatcache();
        $lock_count = 0;

        while(1)
        {
            if (file_exists($lock_file) == FALSE)
            {
                if (touch ($lock_file))
                {
                    $lock_file_heading="locked";
                    if (($lockFileHandler = fopen ($lock_file, "w")) == TRUE)
                    {
                        flock ($lockFileHandler, LOCK_EX); // exclusive lock
                        fwrite ($lockFileHandler, $lock_file_heading);
                        break;
                    }
                }
            }
            clearstatcache();
            sleep(1);

            $lock_count = $lock_count + 1;
            if ($lock_count > 180)
            {
                $log_msg_strings.="Fail to lock file. ";
                break;
            }
        }

        reset($HTTP_POST_VARS);
        $req = '';
        $t_value="";
        foreach ($_POST as $key => $value) 
        {
            $t_value = stripslashes($value); //for logging purpose
            $value = urlencode(stripslashes($value));
            $req .= "&$key=$value";
            $log_msg_strings_posted .="&$key=$t_value"; //for logging purpose
        }

        if (isset($_POST['jobCoverPage'])) $print_jobCoverPage =$_POST['jobCoverPage'];
        else $print_jobCoverPage ="";

        if (isset($_POST['jobColor'])) $print_jobColor =$_POST['jobColor'];
        else $print_jobColor ="";

        if (isset($_POST['jobReleasePort'])) $print_jobReleasePort =$_POST['jobReleasePort'];
        else $print_jobReleasePort ="";

        if (isset($_POST['docFormatApp'])) $print_docFormatApp =$_POST['docFormatApp'];
        else $print_docFormatApp ="";

        if (isset($_POST['jobDestination'])) $print_jobDestination =$_POST['jobDestination'];
        else $print_jobDestination ="";

        if (isset($_POST['jobPageCount'])) $print_jobPageCount =$_POST['jobPageCount'];
        else $print_jobPageCount ="";

        if (isset($_POST['jobReferenceID'])) $print_jobReferenceID =$_POST['jobReferenceID'];
        else $print_jobReferenceID ="";

        if (isset($_POST['jobType'])) $print_jobType =$_POST['jobType'];
        else $print_jobType ="";

        if (isset($_POST['jobInternalID'])) $print_jobInternalID =$_POST['jobInternalID'];
        else $print_jobInternalID ="";

        if (isset($_POST['jobCopies'])) $print_jobCopies =$_POST['jobCopies'];
        else $print_jobCopies ="";

        if (isset($_POST['jobDateTime'])) $print_jobDateTime =$_POST['jobDateTime'];
        else $print_jobDateTime ="";

        if (isset($_POST['jobMediaSizeName'])) $print_jobMediaSizeName =$_POST['jobMediaSizeName'];
        else $print_jobMediaSizeName ="";

        $q="SELECT * FROM ".$print_table." where refid = '$jobReferenceID'";
        $result=db_query($q);
        $U_NAME = "";
        $pageCount = "";
        while(odbc_fetch_row($result))
        { 
            $U_NAME=odbc_result($result,"username");
            $pageCount=round(odbc_result($result,"page"));
        }

        //1 cover page difference
        if($U_NAME != "" && ((($print_jobPageCount-1)==$pageCount) || $print_jobPageCount==$pageCount))
        {
            $settingobj = new COM("FSCONFIG.Cfgmgr") or die("print_auth.php Object cannot be created!");
            $radius = $settingobj->getKey( "use_radius", "radius" );
            if( $radius=="true" ){
                $FSAuthObj = new COM('FSAUTH.Authserv') or die('print_auth.php FSAUTH.Authserv Object cannot be created!');
                $totalpage = $FSAuthObj->UpdatePrintQuota($U_NAME,$_SERVER['REMOTE_ADDR'],$pageCount);
                //$FSAuthObj->Release();
                $FSAuthObj=null;
            }
            //$settingobj->Release();
            $settingobj=null;

            $q="SELECT pagenum FROM ".$fsusr_table." where name = '".$U_NAME."';";
            $result=db_query($q);
            $pagenum = "";
            while(odbc_fetch_row($result))
            {
                $pagenum=odbc_result($result,"pagenum");
            }
            
            if($pagenum == "" || $pagenum == null)
                $q = "UPDATE ".$fsusr_table." SET pagenum = NULL WHERE name = '".$U_NAME."';";
            else if(($pagenum - $pageCount)>0)
                $q = "UPDATE ".$fsusr_table." SET pagenum = pagenum - ".$pageCount." WHERE name = '".$U_NAME."';";
            else
                $q = "UPDATE ".$fsusr_table." SET pagenum = 0 WHERE name = '".$U_NAME."';";
            $result_update=db_query($q);

            $q = "UPDATE ".$print_table." SET ";
            $q .= "stat = 'Completed', ";
            if ($print_jobDateTime != "")
                $q .= "logtime = '$jobDateTime', ";
            if ($print_jobCoverPage != "")
                $q .= "cover = '$print_jobCoverPage', ";
            if ($print_jobMediaSizeName != "")
                $q .= "size = '$print_jobMediaSizeName', ";
            if ($docFormatApp != "")
                $q .= "format = '$docFormatApp', ";
            if ($print_jobReleasePort != "")
                $q .= "port = '$print_jobReleasePort', ";
            if ($print_jobInternalID != "")
                $q .= "intid = '$print_jobInternalID' ";
            $q .= "WHERE refid = '$jobReferenceID'";
            $result_update=db_query($q);
        }
        else
        {
            //page count not match or no such referenceid
        }

        if ($lockFileHandler)
        {
            flock ($lockFileHandler, LOCK_UN ); // release the lock
            fclose ($lockFileHandler);
            while (!unlink($lock_file))
            {
                $log_msg_strings.=" Fail to delete the lock file. ";
            }
        }

        $buff = file_get_contents($print_log);
        $openFileCountTimeOut = 0;

        // retry for 6 hrs per 3 seconds, then timeout
        while ((($fileHandler = fopen ($print_log, "w")) == false) && ($openFileCountTimeOut < 7200))
        {
            sleep(3);
            $openFileCountTimeOut = $openFileCountTimeOut + 1;
            $buff = file_get_contents($print_log);
        }
        while (!flock ($fileHandler, LOCK_EX)) // exclusive lock
        {
            sleep(3);
            $log_msg_strings.="Fail to lock file. ";
        }

        //log the posted strings to the txn log file
        if ( !isset($U_NAME)) 
            $U_NAME="";

        $log_msg_strings =$print_jobReferenceID."\t".$print_jobType."\t".$print_jobDestination."\t".$print_jobPageCount."\t".$print_jobCoverPage."\t".$print_jobMediaSizeName."\t".$print_jobColor."\t".$print_jobReleasePort."\t".$print_jobDateTime."\t".$print_docFormatApp."\t";
        $log_msg_content= $log_msg_ip."\t".$U_NAME."\t".$log_msg_strings.$log_msg_strings_posted."\r\n";

        fwrite ($fileHandler, $buff.$log_msg_content);
        flock ($fileHandler, LOCK_UN ); // release the lock
        fclose ($fileHandler);

    /*
    $printeron_log="printeron.log";
        $fileHandler = fopen ($printeron_log, "w");
        $log_msg_heading = $print_jobDestination." ".$print_jobPageCount." ".$print_jobReferenceID." ".$print_jobType." ". $print_jobInternalID." ". $print_jobCopies ." ".$print_jobDateTime." ". $print_jobMediaSizeName;
        fwrite ($fileHandler, $log_msg_heading);
        fclose ($fileHandler);
    */
    }
?>
