<?php

if (isset($_SESSION['sess_sslpage']))
{
    $sslpage ="&sslpage=".$sess_sslpage;
}
else
{
    $sslpage = "";
}
if (isset($_SESSION['sess_loginPage']))
{
    $loginPage ="&loginPage=".$sess_loginPage;
}
else
{
    $loginPage = "";
}

//It is very important that to unset the session cookies here
//since the session cookies are started by auto (see php.ini)
//Unsetting it here can stop those DoS requests
session_unset(); 
session_destroy(); 

// divert to different php depending on whether it's anonymous mode

require_once "common_functions.php";
require_once "fs_lang.php";
require_once 'generate_common.php';

// extract all parameter in original URL passed from dispatcher
$req="";
foreach ($_GET as $key => $value) {
    $value = urlencode(stripslashes($value));
    $req .= "&$key=$value";
}
if ($req != "" ) $req="?".$req . $sslpage . $loginPage;

//*************************************************************************************
$settingobj = new COM("FSCONFIG.Cfgmgr") or die("login_select.php FSCONFIG.Cfgmgr Object cannot be created!");
// connect to database
$dsn_file = $settingobj->getKey( "Datasource", "gateway");
$dsn_source = fopen($dsn_file, "r") or die("Cannot open DSN source file!");  
$dsn="";
if(!feof($dsn_source)) 
    $line=fgets($dsn_source,512);
while(!feof($dsn_source)){
    $line=fgets($dsn_source,512);
    if (trim($line)!="")
        $dsn=$dsn.$line;
}
$dsn        = str_replace("\r\n",";",$dsn);

// 20090326 - Suppress SQL error
$er = error_reporting(0);
$userDB = odbc_connect($dsn, "", "");
error_reporting($er);

$vers="";
$vers=$settingobj->getKey( "version", "version");

$max_user=0;
$max_user=$settingobj->getKey( "max_conc_user", "gateway");
if ($max_user <0 || $max_user==''){
	$max_user=0;
}

$linkStr = '';
$resultStr = '';
if($userDB) {
        //*************************************************************************************
        // query for timeleft and login time for this client in firstspot user table
        $firstspotusertable=$settingobj->getKey( "Datasource_Tablename", "gateway");
        // count the concurrent user
        $query  = "SELECT reserved1 FROM ".$firstspotusertable.";";
        $result = odbc_exec($userDB,$query);
        $i      = 0;
        while(odbc_fetch_row($result)) {
            $RESERVED1[$i] = odbc_result($result, 1);
            $i++;
        }
        //echo "result=[".$result."]<br>[".$i."]<br>";
        $loginCount = 0;
        if(isset($RESERVED1)) {
            for($j=0;$j<sizeof($RESERVED1);$j++) {
                if($RESERVED1[$j]!=null)
                    $loginCount++;
            }
        }
        
        // count the concurrent user which using passive login 
        $query  = "SELECT reserved1 FROM ".$firstspotusertable." WHERE MACasUsr = 'Y' and pwd is null;";
        $result2 = odbc_exec($userDB,$query);
        $m      = 0;
        while(odbc_fetch_row($result2)) {
            $RESERVED2[$m] = odbc_result($result2, 1);
            $m++;
        }
        $passiveLoginCount = 0;
        if(isset($RESERVED2)) {
            for($j=0;$j<sizeof($RESERVED2);$j++) {
                if($RESERVED2[$j]!=null)
                    $passiveLoginCount++;
            }
        }
        
        //echo $loginCount." user(s) logged in (include passive: ".$passiveLoginCount.")and max concurrent user is set ".$max_user;
        
        //*************************************************************************************
   	if ( ($loginCount < 5 || $vers !="Trial") && (($loginCount - $passiveLoginCount) < $max_user || $max_user  == 0) ){
        // go get the corresponding login form 
        header ("Location: ".fs_form_to_load().$req);
        exit;
    } else {
	    $reach_conc_limit_Msg="";
	    if ($vers =="Trial")
	    	$reach_conc_limit_Msg = get_var('reach_conc_limit_trial');
	    else
	    	$reach_conc_limit_Msg = get_var('reach_conc_limit');
    }
    
    $resultStr = '
		<span class="welcomespan">'.get_var('greeting').'<br><br></span>
		<span class="welcomespan">'.$reach_conc_limit_Msg.'</span>';
    $linkStr = '
    <table border="0" width="100%">
	<tr>
	    <td width="5%">&nbsp;</td>
	    <td width="68%">
		<a class="freelink" href="/local_content_eg.html">'.get_var('example').'</a><br><br>
		<span class="textspan">'.get_var('free_website').'</span><br>
		<a class="freelink" href="http://www.google.com" >Google (Homepage)</a><br>
		<a class="freelink" href="http://images.google.com" >Google Image Search</a><br>
		<a class="freelink" href="http://groups.google.com" >Google Groups</a>
	    </td>
	    <td valign="bottom">
		<span class="textspan">'.get_var('login_form_tech_by').'<br></span>
		<a class="freelink" href="http://www.patronsoft.com/firstspot"><img border="0" src="trialmode.dll?IMAGE=IDR_PATRONSOFT"></a>
	    </td>
	</tr>
    </table>';

    odbc_close($userDB);
} else {
    $resultStr = '
		<span class="welcomespan">'.get_var('login_database_unavailable').'</span>';
}

// release the COM object
//$settingobj->Release();
$settingobj=null;

// 20080407 - Collect dynamic HTML content for layout
$smarty = new SmartyConnect;
$smarty->assign('L_LOGIN_SELECT_CHARSET', metaCharset());
$smarty->assign('L_LOGIN_SELECT_RESULT', $resultStr);
$smarty->assign('L_LOGIN_SELECT_LINK', $linkStr);
$smarty->assign('J_COMMON', $j_common);

// 20080407 - Move layout content and include the file here
$smarty->display('login_select_body.tpl');

?>
