<?php
require_once "fs_lang.php";
require_once("common_functions.php");

$use_radius = "false";
$dsn_file = "";
$dsn_source = "";
$dsn="";
$line="";
$userDB="";
$q="";
$result="";
$reserved1="";
$jsHeader = ''; // 20080407

// 20080407 - Exit if username is not found (occur when directly run this file)
if (!isset($username)) {
    die("popup.php username not found!");
}

// get the absolute path and infobox port
$urlhead=fs_urlhead("infobox");

if( !isset($count) )
    $count = 0;

if( !isset($settingobj) )
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("popup.php FSCONFIG.Cfgmgr Object cannot be created!");

$use_radius = $settingobj->getKey( "use_radius", "radius");

if( strtolower($use_radius)== "true" ){
    $dsn_file = $settingobj->getKey( "Datasource", "radius");
}else{
    $dsn_file = $settingobj->getKey( "Datasource", "gateway");
}
// free the COM object
//$settingobj->Release();
$settingobj=null;  

$dsn_source=fopen($dsn_file, "r") or die("Cannot open DSN source file!");

if (!feof($dsn_source))
    $line=fgets($dsn_source,512);

while (!feof($dsn_source)) {
    $line=fgets($dsn_source,512);
    if (trim($line)!="")
        $dsn=$dsn.$line;
}

$dsn=str_replace("\r\n",";",$dsn);
$userDB=odbc_connect($dsn,"","");
$q = "SELECT reserved1 FROM ".fs_usr_table()." where name='".$username."';";
if( isset($userDB) ) {
    $result = odbc_exec($userDB,$q);
    if( isset($result) ) {
        $reserved1 = odbc_result($result, 'reserved1');
        if( !isset($reserved1) )
            $reserved1 = "";
    }else
        $reserved1 = "";
}
odbc_close($userDB);

if( $reserved1>0 ) {
    $jsHeader = "
        setTimeout(\"self.location = '".$urlhead."info.php'\", 1000);
        self.focus();";
}else if( isset($count)&&($count>10) ) {
    $jsHeader = "
        window.close();";
}else {
    $count = $count + 1;
    $jsHeader = "
        setTimeout(\"self.location = 'popup.php?rand=".(rand()%100000000000)."&username=".$username."&count=".$count."'\", 1000);";
}

// 20080407 - Collect dynamic HTML content for layout
$smarty = new SmartyConnect;
$smarty->assign('L_POPUP_TITLE', get_var('popup_title'));
$smarty->assign('J_POPUP_HEADER', $jsHeader);
$smarty->assign('L_POPUP_WAIT', get_var('ReqSignUp_wait'));

// 20080407 - Move layout content and include the file here
$smarty->display('popup_body.tpl');

?>

