<?php
require_once 'secureLogin.php'; //prevent hacker from running this script by setting GET variables
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>SetIBMsg</title>
<meta http-equiv="Content-Type" content="text/html;charset=ISO-8859-1" />
<link rel="stylesheet" href="setcfg.css" type="text/css">
<style type="text/css">
    iframe, form { margin-bottom: 8px; }
</style>
<?php

$category = 'ibmsg';
require_once "cmvar.php";
require_once ("..\\authserv\\common_functions.php");
require_once "validate.php";

    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');
	
	$version = $settingobj->getKey('version', 'version');

	// 20090518 - Remove Start
	// version control
	if (substr_count(strtolower($version), 'standard') > 0) {
        if (substr_count(strtolower($version),'donation')>0)
            $version = substr($version,0,strlen($version)-9);
        $disabled = ' disabled';
        $version_msg = '* This feature is not available in '. ucwords($version) .' Edition.';
        $version_star = '<span class="star">* </span>';
    } else {
        $disabled = '';
        $version_msg = '';
        $version_star = '';
    }
	
	$session_handling = $settingobj->getKey( "session_handling", "gateway");
	
	// scenario2 and load balancing
	$isScenario2 = $settingobj->getKey('scenario2', 'gateway');
	$FOMode=$settingobj->getKey('mode', 'FSFO');
	$curr_ID="";

	$enableLoadBalancing=0;
	if($FOMode == 3){
		$enableLoadBalancing=1;
		$curr_ID = $settingobj->getKey('MachineID', 'FSFO');
	}
	else if ($isScenario2){
		$curr_ID = $settingobj->getKey('siteID', 'gateway');
	}
	
	if ($isScenario2 || $enableLoadBalancing)
		$conditionSiteID=" siteID ='".$curr_ID."' ";
	else
		$conditionSiteID=" siteID is NULL or siteID ='' ";
		
	$enableFailover=0;
	$condMsgSiteID=""; // format siteID_XXXMachine
	$msgSiteID="";
	if ($FOMode == 1 || $FOMode == 2){
		$enableFailover=1;
		if ($isScenario2)
			$msgSiteID = $curr_ID."_";
			
		if ($FOMode == 1)
			$msgSiteID .= "MainMachine";
		else if ($FOMode == 2)
			$msgSiteID .= "BackupMachine";
			
		$condMsgSiteID=" siteID ='".$msgSiteID."' ";
		
	}

	$use_radius = $settingobj->getKey( 'use_radius', 'radius');

	// connect to database
	if( strtolower($use_radius)== 'true' ) {
		$dsn_file = $settingobj->getKey( 'Datasource', 'radius');
	}else{
		$dsn_file = $settingobj->getKey( 'Datasource', 'gateway');
	}

	$dsn_source = fopen($dsn_file, 'r') or die('Cannot open DSN source file!');  
	$dsn='';

	if(!feof($dsn_source)) 
		$line=fgets($dsn_source,512); 

	while(!feof($dsn_source)) {
		$line=fgets($dsn_source,512);
		if (trim($line)!='') $dsn.=$line;
	}

	$dsn=str_replace("\r\n",';',$dsn);

	$ibmsg_tablename = $settingobj->getKey('Datasource_ibmsg_Tablename', 'gateway');
	
	$settingobj=null;
	$defaultDisplay1 = '';
	
	// init width of each cell
	$checkboxCellWidth="3%";
	$typeCellWidth="15%";
	$creationTimeCellWidth="20%";
	$titleCellWidth="25%";
	$messageCellWidth="37%";
	
if(isset($ibmsg_del_Status)) // delete ibmsg record
	{
	
		$errOccur= false;
	
		$del_Record = explode(',', $ibmsg_del_str);
		
		// one record by one statement
		
		if (file_exists("..\\authserv\\msgByIBMsg.php")) {
			ob_start();
			require_once "..\\authserv\\msgByIBMsg.php";
			ob_end_clean();
		}
			
		// rebuild the message php file 
		$fh = fopen("..\\authserv\\msgByIBMsg.php", "w") or die("can't open file");
		
		if ($fh){
			$userDB=odbc_connect($dsn,'','');
			
			$cond1="";
			if ($enableFailover)
				$cond1 = $condMsgSiteID;
			else
				$cond1 = $conditionSiteID;
			
			foreach($del_Record as $val){
				$cond2 ="";
				$arr = explode('|', $val);
				// print_r($arr);
				// [0] ibmsgTime, [1]ibmsgID, [2]ibmsgType, [3] conRefID
				$cond2 .= "( ibmsgTime = ".$arr[0]." and ibmsgID = ".$arr[1]." and ibmsgType = ".$arr[2]." )";
				$query="Delete from ".$ibmsg_tablename." where ($cond1) and ".$cond2.";";
				$result=odbc_exec($userDB,$query);
				
				if ($result){
				
					if(isset($txtmsg['ibmsg_g_frequency_'.$arr[3]]) ){
						$txtmsg['ibmsg_g_frequency_'.$arr[3]] --;
					}
					else
						$txtmsg['ibmsg_g_frequency_'.$arr[3]] = 0;
					
					if ($txtmsg['ibmsg_g_frequency_'.$arr[3]] <=0){
						// erase the record
						$txtmsg['ibmsg_g_title_'.$arr[3]] = "";
						$txtmsg['ibmsg_g_msg_'.$arr[3]] = "";
						$txtmsg['ibmsg_g_frequency_'.$arr[3]] = "";
					}
					odbc_free_result( $result );
				}
				else{
					// error fail to delete that record
				}
			}
			// close the odbc connection
			odbc_close($userDB);
			
			// rebuild the message php file
			if ($fh){
			  fwrite($fh, "<?php\r\n");
			  
			  foreach ($txtmsg as $key => $value) {
				if (strcmp("$value", "") != 0) {
					fwrite($fh, '$txtmsg[\''.$key.'\']=');
					fwrite($fh, "\"".$value."\"");
					fwrite($fh, ";\r\n");
				}
			}

			  fwrite($fh, "?>\r\n");
			  fclose($fh);
			}
		}
		else{
			// error fail to open message php file
		}
	}

if (isset($_POST['send'])) // add message
  {
		if (file_exists("..\\authserv\\msgByIBMsg.php")) {
			ob_start();
			require_once "..\\authserv\\msgByIBMsg.php";
			ob_end_clean();
		}
			
		// rebuild the message php file 
		$fh = fopen("..\\authserv\\msgByIBMsg.php", "w") or die("can't open file");
		
		// hard code 
		$maxEntry = 100; // entry include global and personal
		
		$errOccur= false;
		
		if ($fh){
			// * direct access variable in msgByIBMsg.php
			if (isset($txtmsg['ibmsg_g_count']) && $txtmsg['ibmsg_g_count'] < $maxEntry)
				$count = $txtmsg['ibmsg_g_count'] +1;
			else
				$count = 1;
			
			$add_Record =array();
			$freq = 0;
			
			if ($msg_type == 1){
				// global
				$add_Record[0] = "";
				$freq = 1;
			}			
			else if ($msg_type == 2){
				// personal
				$add_Record = explode(',', $msg_to);
				$freq = sizeof($add_Record);
			}
			
			for ($n =1; $n < $maxEntry; $n++){
				if (!isset ($txtmsg['ibmsg_g_msg_'.$count]) || $txtmsg['ibmsg_g_msg_'.$count] == ""){
					// 20090617 - Remove backslash from HTML
					$txtmsg['ibmsg_g_title_'.$count] = htmlspecialchars(stripslashes($msg_title));
					$txtmsg['ibmsg_g_msg_'.$count] = htmlspecialchars(stripslashes($msg_body));
					$txtmsg['ibmsg_g_frequency_'.$count] = $freq;
					$txtmsg['ibmsg_g_count'] = $count;
					break;
				}
				$count ++;
				if ($count >= $maxEntry){
					$count = 1;
				}
			}
			
			// rebuild the message php file
			if ($fh){
			  fwrite($fh, "<?php\r\n");
			  
			  foreach ($txtmsg as $key => $value) {
				if (strcmp("$value", "") != 0) {
					// 20090617 - Add backslash processing
					$value = str_replace("\\", "\\\\", $value);
					fwrite($fh, '$txtmsg[\''.$key.'\']=');
					fwrite($fh, "\"".$value."\"");
					fwrite($fh, ";\r\n");
				}
			}

			  fwrite($fh, "?>\r\n");
			  fclose($fh);
			}
		}
		else{
			// error fail to open message php file
			$errOccur = true;
		}
		
		if(!$errOccur){
			$userDB=odbc_connect($dsn,'','');
			
			$current_time = time();
			$current_d = date("m-d-Y", $current_time);
			
			$cond1="";
			if ($enableFailover)
				$cond1 = $condMsgSiteID;
			else
				$cond1 = $conditionSiteID;

			$q = "SELECT max(ibmsgid) as maxID FROM ".$ibmsg_tablename." where ($cond1) and ibmsgtime >= ".mktime_from_datetime($current_d, "00:00").";";
			
			$result = odbc_exec( $userDB, $q );
			
			$RequestID = odbc_result( $result, 'maxID' );
			if( $RequestID>0 ){
				$updateID = $RequestID +1;
			}
			else{
				$updateID = 1;
			}
			
			odbc_free_result( $result );
			
			
			$insertColName ="";
			$insertColValue = "";
			
			if ($enableFailover){
				$insertColName =", siteID";
				$insertColValue = ", '".$msgSiteID."'";
			}
			else if ($enableLoadBalancing || $isScenario2){
				$insertColName =", siteID";
				$insertColValue = ", '".$curr_ID."'";
			}
			
			$snList="";
			$fnList="";
			
			$countSucc=0;
			$countFail=0;
			
			foreach($add_Record as $val){
				$insertColName2 ="";
				$insertColValue2 = "";
				if ($msg_type == 2){
					// personal
					$insertColName2 .=", name";
					$insertColValue2 .= ", '".$val."'";
				}
				
				$q = "insert into ".$ibmsg_tablename." (ibmsgID, ibmsgType, ibmsgTime, conRefID ".$insertColName.$insertColName2.") values (".$updateID.",".$msg_type.",".$current_time.",".$txtmsg['ibmsg_g_count']." ".$insertColValue.$insertColValue2.")";
				
				$result = odbc_exec( $userDB, $q );
				
				if ($result){
					if ($countSucc == 0){
						$snList.= $val;
					}
					else{
						$snList.= ",".$val;
					}
					$countSucc++;
					$updateID++;
				}
				else{
					if ($countFail == 0){
						$fnList.= $val;
					}
					else{
						$fnList.= ",".$val;
					}
					$countFail++;
				}
				odbc_free_result( $result );
			}
			
			if ($countFail != 0){
				$fh = fopen("..\\authserv\\msgByIBMsg.php", "w") or die("can't open file");
				
				if ($countSucc == 0){
					// no record insert success
					// erase the record from the message php file
					$txtmsg['ibmsg_g_title_'.$txtmsg['ibmsg_g_count']] = "";
					$txtmsg['ibmsg_g_msg_'.$txtmsg['ibmsg_g_count']] = "";
					$txtmsg['ibmsg_g_frequency_'.$txtmsg['ibmsg_g_count']] = "";
				}
				else{
					// some record insert success, some not
					$txtmsg['ibmsg_g_frequency_'.$txtmsg['ibmsg_g_count']] = $countSucc;
				}
				
				if ($fh){
				  fwrite($fh, "<?php\r\n");
				  
				  foreach ($txtmsg as $key => $value) {
					if (strcmp("$value", "") != 0) {
						fwrite($fh, '$txtmsg[\''.$key.'\']=');
						fwrite($fh, "\"".$value."\"");
						fwrite($fh, ";\r\n");
					}
				}

				  fwrite($fh, "?>\r\n");
				  fclose($fh);
				}
			}
			
			if($countSucc > 0){
			
				// create a COM object
				$settingobj = new COM('FSCONFIG.Cfgmgr') or die('iBMsg.php FSCONFIG.Cfgmgr Object cannot be created!');

				$settingobj->setKey( "1", 'iBMsg', 'IB' );
				$fs_status=$settingobj->queryService();
				if ($fs_status=="STARTED")
				{
					$myobj = new COM('FSAUTH.Authserv') or die('announcement.php FSAUTH.Authserv object cannot be created!');
					
					$q = 'select  name, reserved1 from '.fs_usr_table()." where ($conditionSiteID) and reserved1 IS NOT NULL;";

					$result = odbc_exec( $userDB, $q );
					
					$snArray = Array();
					
					// * for case-insensitive string strtoupper
					
					if ($msg_type == 2){
						if ($countSucc > 1){
							$snArray = explode(',', strtoupper($snList));
						}
						else {
							$snArray[0] = strtoupper($snList);
						}
					}
					
					$nameString="";
					
					while (odbc_fetch_row($result)){
						$name=odbc_result($result,"name");
						
						if ($msg_type == 1 || ($msg_type== 2 && in_array(strtoupper($name), $snArray) )){
							if($nameString!=""){
								$nameString.=",";
							}
							
							$nameString.=$name;
						}
					}
					
					if ($nameString != "")
						$rsult= $myobj->SetIBMsgByName($nameString);
					
					$myobj = null;
				}
				
				$settingobj=null;
			}
			// close the odbc connection
			odbc_close($userDB);
		}
  }

  if (isset($_POST['stop'])) // stop In-browser message
  {
	$userDB=odbc_connect($dsn,'','');
	
	if($userDB) {
	
		$cond1="";
		if ($enableFailover)
			$cond1 = $condMsgSiteID;
		else
			$cond1 = $conditionSiteID;
	
		$query="Delete from ".$ibmsg_tablename." where ($cond1) ;";
		$result=odbc_exec($userDB,$query);
		// close the odbc connection
		odbc_close($userDB);
	}
	
	// erase all entry from the file, and then rewrite init state
	
    $fh = fopen("..\\authserv\\msgByIBMsg.php", "w") or die("can't open file");
    if ($fh){
      fwrite($fh, "<?php\r\n");
      
      $count = 0;

      fwrite($fh, '$txtmsg[\'ibmsg_g_count\']=');
      fwrite($fh, "\"".$count."\"");
      fwrite($fh, ";\r\n");

      fwrite($fh, "?>\r\n");
      fclose($fh);
    }
	
	// // write log
    // $fh = fopen("..\\log\\ibmsg.log", "a");
    // if ($fh){
      // fwrite($fh, "*In-browser message stopped at ".strftime("%Y %b %d %H:%M:%S")."*\r\n");
      // fclose($fh);
    // }

  }

?>
</head>
<body>
<script type="text/javascript" src="./javascript/ibmsg.js"></script>
</script>
<table width="100%" cellspacing="0" cellpadding="0">
<tr>
<td width="50%" valign="top">
<?// Sending Message Part?>
<form action="" name="form_ibmsg" method="post">
<table width = "94%" align='left'>
<tr>
<td class="normal">
<font color="green" face="sans-serif" size="4"><?php echo get_cm_var('setcfg_ibmsg_type'); ?></font>
</td>
<td class="normal">
<input type="radio" checked  name="msg_type" value="1" onclick="chType(this)">Global
<input type="radio" name="msg_type" value="2" onclick="chType(this)">Personal
</td>
</tr>
<tr id="toCell" style="display:none;" >
<td class="normal" valign="top">
<font color="green" face="sans-serif" size="4"><?php echo get_cm_var('setcfg_ibmsg_to'); ?></font>
</td>
<td class="normal">
<div ><input name="msg_to" type=text size="30" maxlength="256" style="border: 1px solid seagreen; height: 20px;" value="" /><br/><?php echo get_cm_var('setcfg_ibmsg_to_remark'); ?></div>
</td>
</tr>
<?gen_sep();?>
<tr>
<td class="normal" width = "20%">
<font color="green" face="sans-serif" size="4"><?php echo get_cm_var('setcfg_ibmsg_title'); ?></font>
</td>
<td class="normal">
<input name="msg_title" type=text size="30" maxlength="30" style="border: 1px solid seagreen; height: 20px;" value="" />
</td>
</tr>
<tr>
<td colspan = 2>
<textarea name="msg_body" cols=36 rows=8 style="width: 340px; border: 1px solid seagreen; overflow-x: hidden;"></TEXTAREA>
</td>
</tr>
<tr>
<td colspan = 2>
<input type="submit" class="graphicBtn" name="send" value="<?=get_cm_var('setcfg_ibmsg_btn_send')?>" onclick="return validate_ibmsgSend()" />  <input type="submit" class="graphicBtn" name="stop" value="<?=get_cm_var('setcfg_ibmsg_btn_stop')?>"  onclick="return confirmStopIBMsg()"/><font color="red"></font>
</td>
</tr>
</table>
</form>
<?// End of Sending Message Part?>
</td>
<td width="50%" valign="top">
<?// Message Record Part?>
<font color="green" face="sans-serif" size="4"><?php echo get_cm_var('setcfg_ibmsg_history'); ?></font><br>
<form action="" name="form_ibmsg_record" method="post">
<input type="hidden" name="ibmsg_del_str">
<input type="hidden" name="ibmsg_del_Status">
<iframe id="users_frame" name="usersFrame" frameborder="0" width="100%" height="300" src="table_ibmsg.php" marginwidth="0" marginheight="0" class="bordered_frame" scrolling="yes"></iframe> 
</form>
<?// End of Message Record Part?>
<br/>
<input type="button" value="<?=get_cm_var('setcfg_ibmsg_btn_del')?>" title="<?=get_cm_var('setcfg_ibmsg_del')?>" onClick="if (confirmDeleteMessage(document.form_ibmsg_record.ibmsg_del_str.value) == true){document.form_ibmsg_record.ibmsg_del_Status.value=''; document.form_ibmsg_record.submit();}else return false;" class="graphicBtn"/>
</td>
</tr>
</table>

</body>
</html>
