var glo_isEditMode = false; //indicate whether edit mode is on/off

function switchToEditMode() {
    /*
     *  Purpose: Enable the userinfoform to allow user editing
     */
    var tempNode;
    var oFrameDoc = getFrameDocument(frames['loadplans']);
    var oLoadPlan = oFrameDoc.getElementById('loadplan');
    if (!isMultipleUserSelected()) {
        glo_isEditMode = true;
        //Show necessary object
        document.getElementById('chpwRow').style.display = ''; //change password
        document.getElementById('cfpwRow').style.display = ''; //confirm password
        document.getElementById('passive').style.display = ''; //passive login
        document.getElementById('addtimeleft').style.display = ''; //add timeleft
        document.getElementById('addQuotaRow').style.display = ''; //add DL quota
        document.getElementById('addQuotaULRow').style.display = ''; //add UL quota
		document.getElementById('addQuotaSHARow').style.display = ''; //add TOTAL quota
        document.getElementById('saveBtn').style.display = ''; //userinfoform save button
        document.getElementById('cancelBtn').style.display = ''; //userinfoform cancel button

        //hide unnecessary object
        tempNode = document.getElementById('prepaidBtn'); //add prepaid user
        if (tempNode) { //prepaid button is not available in search user mode
            tempNode.style.display = 'none';
        }
        tempNode = document.getElementById('addUserBtn'); //add user
        if (tempNode) { //addUser button is not available in search user mode
            tempNode.style.display = 'none';
        }
        document.getElementById('editUserBtn').style.display = 'none'; //edit user
        document.getElementById('deleteUserBtn').style.display = 'none';  //delete user
        document.getElementById('refresh_btn').style.display = 'none';  //delete user
        document.getElementById('extraInfoBtn').style.display = 'none';  //delete user
		oLoadPlan.disabled = false; //enable plan selection
        changeUser(); //pass the job of enable/disable different elements to changeUser()
    }
}

function freezeForm(formName) {
    //disabled all field in form
    with (document.forms[formName]) {
        for (var i=0; i<elements.length; i++) {
            //disable all form elements in userinfoform
            if (elements[i].type) { //prevent disabling 'fieldset' element
                elements[i].disabled = true; //Disable non-text field
            }
        }
    }
}

function  unfreezeForm(formName) {
    //Enable all form elements
    with (document.forms[formName]) {
        for (var i=0; i<elements.length; i++) {
            if (elements[i].type) { //prevent altering 'fieldset' element
                elements[i].disabled = false;
                elements[i].readOnly = false;
            }
        }
    }
}

function cancelEdit() {
    /*
     *  Purpose: Restore the userinfoform when user click cancel
     *  during user editing
     */
    var tempNode;
    var oFrameDoc = getFrameDocument(frames['loadplans']);
    var oLoadPlan = oFrameDoc.getElementById('loadplan');
    glo_isEditMode = false;
    //hide unnecessary object
    document.getElementById('chpwRow').style.display = 'none'; //change password
    document.getElementById('cfpwRow').style.display = 'none'; //confirm password
    document.getElementById('passive').style.display = 'none'; //passive login
    document.getElementById('addtimeleft').style.display = 'none'; //add timeleft
    document.getElementById('addQuotaRow').style.display = 'none'; //add DL quota
    document.getElementById('addQuotaULRow').style.display = 'none'; //add UL quota
	document.getElementById('addQuotaSHARow').style.display = 'none'; //add SHA quota
    document.getElementById('saveBtn').style.display = 'none'; //save button
    document.getElementById('cancelBtn').style.display = 'none'; //cancel button
    //Show necessary object
    tempNode = document.getElementById('prepaidBtn'); //add perpaid user button
    if (tempNode) { //prepaid button is not available in search user mode
        tempNode.style.display = '';
    }
    tempNode = document.getElementById('addUserBtn');  //add user button
    if (tempNode) { //addUser button is not available in search user mode
        tempNode.style.display = '';
    }
    document.getElementById('editUserBtn').style.display = ''; //edit user button
    document.getElementById('deleteUserBtn').style.display = ''; //delete user button
    document.getElementById('refresh_btn').style.display = ''; //delete user button
    document.getElementById('extraInfoBtn').style.display = '';  //delete user
	oLoadPlan.disabled = true; //disable plan selection
    oLoadPlan.selectedIndex = -1 //prevent any plan be selected
    changeUser(); //pass the job of enable/disable different elements to changeUser()
}

function cancelAdd() {
    /*
     *  Purpose: Restore userinfoform when user click 
     *  cancel in adduser form.
     */
    var oFrameDoc = getFrameDocument(frames['loadplans']);
    var oLoadPlan = oFrameDoc.getElementById('loadplan');
    document.userForm.userList.disabled = false; //enable the userList
    document.getElementById('userinfo').style.display='';
    document.getElementById('adduser').style.display='none';

    //show button
    tempNode = document.getElementById('prepaidBtn'); //add prepaid user
    if (tempNode) { //prepaid button is not available in search user mode
        tempNode.style.display = '';
    }
    tempNode = document.getElementById('addUserBtn'); //add user
    if (tempNode) { //addUser button is not available in search user mode
        tempNode.style.display = '';
    }
    document.getElementById('editUserBtn').style.display = ''; //edit user
    document.getElementById('deleteUserBtn').style.display = '';  //delete user
    document.getElementById('resetquotaBtn').style.display = ''; //reset quota
    document.getElementById('refresh_btn').style.display = '';  //delete user
	document.getElementById('extraInfoBtn').style.display = '';  //delete user
	
    changeUser(); //refresh the userinfoform
    oLoadPlan.disabled = true; //disable plan selection
    oLoadPlan.selectedIndex = -1
}

function editActivateAcc(value)
{
    var i;    
    for (i=0; i<3; i++)
        document.userinfoform.usr_bt_acc[i].checked=false;

    document.userinfoform.edit_act_date.disabled=true;
    document.userinfoform.edit_act_time.disabled=true;
    document.userinfoform.edit_act_date.value='';
    document.userinfoform.edit_act_time.value='';
    document.userinfoform.usr_bt_acc[value].checked=true; 
    if(value=='2'){
        document.userinfoform.edit_act_date.disabled=false;
        document.userinfoform.edit_act_time.disabled=false;
    }
}

function editExpireAcc(value)
{
    if(value=='0' && document.userinfoform.usr_cb_acc0.checked==true){
        document.userinfoform.usr_cb_acc1.checked=false;
        document.userinfoform.usr_cb_acc2.checked=false;
        document.userinfoform.usr_cb_acc3.checked=false;
        document.userinfoform.usr_cb_acc4.checked=false;
        if(document.userinfoform.status.value=='Offline')
            document.userinfoform.edit_timeleft.value='';         
        document.userinfoform.edit_addtimeleft.value='';
        document.userinfoform.edit_login.value='';         
        document.userinfoform.edit_exp_date.value='';         
        document.userinfoform.edit_exp_time.value='';         
        document.userinfoform.edit_days.value='';          
    }
    else if (value!='0' && document.userinfoform.usr_cb_acc0.checked==true)
        document.userinfoform.usr_cb_acc0.checked=false;

    document.userinfoform.edit_timeleft.disabled=true;
    document.userinfoform.edit_addtimeleft.disabled=true;
    document.userinfoform.edit_login.disabled=true;          
    document.userinfoform.edit_exp_date.disabled=true;          
    document.userinfoform.edit_exp_time.disabled=true;          
    document.userinfoform.edit_days.disabled=true;
    document.userinfoform.select_edit_timeleft.disabled=true;

    if(document.userinfoform.usr_cb_acc1.checked==true)         
    {
        if(document.userinfoform.status.value=='Offline'){
            document.userinfoform.edit_timeleft.disabled=false;
        }else{
            document.userinfoform.edit_timeleft.disabled=false;
            document.userinfoform.edit_timeleft.readOnly=true;
            document.userinfoform.edit_addtimeleft.disabled=false;
        }
    }
         
    if(document.userinfoform.usr_cb_acc2.checked==true)         
        document.userinfoform.edit_login.disabled=false;

    if(document.userinfoform.usr_cb_acc3.checked==true){
        document.userinfoform.edit_exp_date.disabled=false;
        document.userinfoform.edit_exp_time.disabled=false;
    }

    if(document.userinfoform.usr_cb_acc4.checked==true){
        document.userinfoform.edit_days.disabled=false;
        document.userinfoform.select_edit_timeleft.disabled=false;
    }

    if(document.userinfoform.usr_cb_acc0.checked==false){
        if(value=='1' && document.userinfoform.usr_cb_acc1.checked==true){
            document.userinfoform.usr_cb_acc1.checked=true;
            if(document.userinfoform.status.value=='Offline')
                document.userinfoform.edit_timeleft.disabled=false; 
            else
                document.userinfoform.edit_addtimeleft.disabled=false;
        }   
        else if (document.userinfoform.usr_cb_acc1.checked==false)
        {
            if(document.userinfoform.status.value=='Offline')
                document.userinfoform.edit_timeleft.value='';
            document.userinfoform.edit_addtimeleft.value='';         
        }
     
        if(value=='2' && document.userinfoform.usr_cb_acc2.checked==true){
            document.userinfoform.usr_cb_acc2.checked=true;
            document.userinfoform.edit_login.disabled=false;
        }
        else if (document.userinfoform.usr_cb_acc2.checked==false)
            document.userinfoform.edit_login.value='';

        if(value=='3' && document.userinfoform.usr_cb_acc3.checked==true){
            document.userinfoform.usr_cb_acc3.checked=true;
            document.userinfoform.edit_exp_date.disabled=false;
            document.userinfoform.edit_exp_time.disabled=false;
        }
        else if (document.userinfoform.usr_cb_acc3.checked==false){
                    document.userinfoform.edit_exp_date.value='';
                    document.userinfoform.edit_exp_time.value='';
        }       
    
        if(value=='4' && document.userinfoform.usr_cb_acc4.checked==true){
            document.userinfoform.usr_cb_acc4.checked=true;
            document.userinfoform.edit_days.disabled=false;
            document.userinfoform.select_edit_timeleft.disabled=false;  
        }
        else if (document.userinfoform.usr_cb_acc4.checked==false)
            document.userinfoform.edit_days.value='';
    }    
}

function rbtn(value)
{
    var i;       
    document.userinfoform.user_bt_num.disabled=true;
    document.userinfoform.user_bt_num_dl.disabled=true;
    document.userinfoform.user_bt_num.value='';
    document.userinfoform.user_bt_num_dl.value='';
      
    for (i=0; i<6; i++)
        document.userinfoform.usr_bt_mode[i].checked=false;

    document.userinfoform.usr_bt_mode[value].checked=true; 
    if(value=='5')
    {
        document.userinfoform.user_bt_num.disabled=false;
        document.userinfoform.user_bt_num_dl.disabled=false;
    }
}

function bwparam(value)
{
    var i;  
    for (i=0; i<4; i++)
        document.userinfoform.Bn_bwcount[i].checked=false;

    document.userinfoform.Bn_bwcount[parseInt(value)+1].checked=true;
    document.userinfoform.bwquota1.disabled=true;
    document.userinfoform.bwquota1.value='';
    document.userinfoform.edit_addquota.disabled=true;

    if(value=='2')
    {              
        document.userinfoform.bwquota1.disabled=false;

        if(document.userinfoform.status.value=='Offline'){
            document.userinfoform.edit_addquota.disabled=true;
        }else{
            if(document.userinfoform.bwquota1.value==''){
                document.userinfoform.bwquota1.readOnly=false;          
                document.userinfoform.bwquota1.disabled=false;
                document.userinfoform.edit_addquota.disabled=true;         
            }
            else{
                document.userinfoform.bwquota1.readOnly=true;
                document.userinfoform.bwquota1.disabled=true;
                document.userinfoform.edit_addquota.disabled=false;
            }
        }
    }
}

function bwparamUL(value)
{
    var i;  
    for (i=0; i<4; i++)
        document.userinfoform.Bn_bwcountUL[i].checked=false;

    document.userinfoform.Bn_bwcountUL[parseInt(value)+1].checked=true;
    document.userinfoform.bwquota1UL.disabled=true;
    document.userinfoform.bwquota1UL.value='';
    document.userinfoform.edit_addquotaUL.disabled=true;

    if(value=='2')
    {              
        document.userinfoform.bwquota1UL.disabled=false;

        if(document.userinfoform.status.value=='Offline'){
            document.userinfoform.edit_addquotaUL.disabled=true;
        }else{
            if(document.userinfoform.bwquota1UL.value==''){
                document.userinfoform.bwquota1UL.readOnly=false;          
                document.userinfoform.bwquota1UL.disabled=false;
                document.userinfoform.edit_addquotaUL.disabled=true;         
            }
            else{
                document.userinfoform.bwquota1UL.readOnly=true;
                document.userinfoform.bwquota1UL.disabled=true;
                document.userinfoform.edit_addquotaUL.disabled=false;
            }
        }
    }
}

function bwparamSHA(value)
{
    var i;  
    for (i=0; i<3; i++)
        document.userinfoform.Bn_bwcountSHA[i].checked=false;

    document.userinfoform.Bn_bwcountSHA[parseInt(value)].checked=true;
    document.userinfoform.bwquota1SHA.disabled=true;
    document.userinfoform.bwquota1SHA.value='';
    document.userinfoform.edit_addquotaSHA.disabled=true;

    if(value=='2')
    {              
        document.userinfoform.bwquota1SHA.disabled=false;

        if(document.userinfoform.status.value=='Offline'){
            document.userinfoform.edit_addquotaSHA.disabled=true;
        }else{
            if(document.userinfoform.bwquota1SHA.value==''){
                document.userinfoform.bwquota1SHA.readOnly=false;          
                document.userinfoform.bwquota1SHA.disabled=false;
                document.userinfoform.edit_addquotaSHA.disabled=true;         
            }
            else{
                document.userinfoform.bwquota1SHA.readOnly=true;
                document.userinfoform.bwquota1SHA.disabled=true;
                document.userinfoform.edit_addquotaSHA.disabled=false;
            }
        }
    }
}

function accparam(value)
{
    document.userinfoform.acc_enable.checked=false;
    document.userinfoform.acc_disable.checked=false;
    if(value=='0')
        document.userinfoform.acc_enable.checked=true;

    if(value=='1')
        document.userinfoform.acc_disable.checked=true;
}

function usr_abw_disable_all()
{
    show_hide( 'usr_resetabw_monthly', 1, 'none' );
    show_hide( 'usr_resetabw_daily', 1, 'none' );
    show_hide( 'usr_resetabw_lastrbw', 1, 'none' );
}

function usr_abw_enable_textbox()
{
    show_hide( 'usr_resetabw_monthly', 1, '' );
    show_hide( 'usr_resetabw_daily', 1, 'none' );
    show_hide( 'usr_resetabw_lastrbw', 1, '' );
}

function usr_abw_disable_textbox()
{
    show_hide( 'usr_resetabw_monthly', 1, 'none' );
    show_hide( 'usr_resetabw_daily', 1, '' );
    show_hide( 'usr_resetabw_lastrbw', 1, '' );
}

function show_hide(id, total_num,isshow){
    for (i = 0; i <= total_num; i++){
        content = document.getElementById(id + i);
        content.style.display = isshow;
    }
}

function edit_passive()
{
    if ( document.userinfoform.chg_passive_login.checked == false )
    {
        document.userinfoform.chgpassword.disabled = false;
        document.userinfoform.chgconfirmpass.disabled = false;
        document.userinfoform.chgpassword.style.background = '#FFFFFF';
        document.userinfoform.chgconfirmpass.style.background = '#FFFFFF';
    }
    else
    {
        document.userinfoform.chgpassword.style.background = '#DDDDDD';
        document.userinfoform.chgconfirmpass.style.background = '#DDDDDD';
        document.userinfoform.chgpassword.disabled = true;
        document.userinfoform.chgconfirmpass.disabled = true;
    }
}

function disableRestrictedFunctionInUserinfoform() {
    /*
     *  Purpose:
     *  It disable some elements in userinfoform according to
     *  the glo_version value.
     */
	// 20090518 - Remove Start, add Premium
    switch (glo_version) {
        case "standard":
            with (document.userinfoform) {
                for (var i=0; i<usr_bt_mode.length; i++) {
                    usr_bt_mode[i].disabled = true;
                }
                usr_bt_mode[4].checked = true; //no throttling
                Bn_bwcountUL[3].disabled = true; //no UL quota enforcement
                Bn_bwcount[3].disabled = true; //no quota enforcement
                bwquota1.disabled = true;
                bwquota1UL.disabled = true;
            }
            break;
        case "advanced":
		case "premium":
        case "trial":
            break;
    }
}

function disableRestrictedFunctionInAddform() {
    /*
     *  Purpose:
     *  It disable some elements in addform according to
     *  value stored in glo_version
     */
    switch (glo_version) {
        case "start":
            with (document.addform) {
                bwcountUL[2].disabled = true; //no upload data transfer count
                bwcount[2].disabled = true; //no download data transfer count
            }
        case "standard":
            with (document.addform) {
                userMACaddr1.disabled = true; //no MAC user
                userMACaddr2.disabled = true;
                userMACaddr3.disabled = true;
                userMACaddr4.disabled = true;
                userMACaddr5.disabled = true;
                userMACaddr6.disabled = true;
                add_name_mode[1].disabled = true;
                //macasuser.disabled = true;
                userIPaddr1.disabled = true; //no IP user
								userIPaddr2.disabled = true;
								userIPaddr3.disabled = true;
								userIPaddr4.disabled = true;								
								add_name_mode[2].disabled = true;
                for (var i=0; i<add_bt_mode.length; i++) {
                    add_bt_mode[i].disabled = true; //no bandwidth throttling
                }
                user_bt_num_add.disabled = true;
                user_bt_num_add_dl.disabled = true;
                bwcountUL[3].disabled = true; //no UL quota enforcement
                bwcount[3].disabled = true; //no DL quota enforcement
                bwquotaUL.disabled = true;
                bwquota.disabled = true;
            }
            break;
        case "advanced":
            break;
        case "trial":
            break;
    }
}

function edit_recur_disabled(instance)
{
    if ( instance.value == 1 )
        document.getElementById("edit_schedule").style.display = '';
    else
        document.getElementById("edit_schedule").style.display = 'none';   
}
